#!/usr/bin/python3
# -*- coding: utf-8 -*-
import sys
from oauthlib.oauth2 import BackendApplicationClient
from requests_oauthlib import OAuth2Session
import json


#Access key
#YZ7UPLDGVGGSHQTXSIUN 

#Secret key
#Y00yNywqhBKQYiiSRc6R4bcj0iqeE1qcEIOZxdhE
#===============================================================================
def sentinelhub_compliance_hook(response):
	response.raise_for_status()
	return response

def example():
	# Your client credentials
	client_id = 'sh-933e0ce8-1d52-487b-aa33-358524d21cee'
	client_secret = 'R4a8WW4cuUPVdJXZGwr0BU5QfyMLho9l'

	# Create a session
	client = BackendApplicationClient(client_id=client_id)
	oauth = OAuth2Session(client=client)
	oauth.register_compliance_hook("access_token_response", sentinelhub_compliance_hook)
	# Get token for the session
	token = oauth.fetch_token(token_url='https://identity.dataspace.copernicus.eu/auth/realms/CDSE/protocol/openid-connect/token',
		client_secret=client_secret)

	# All requests using this session will have an access token automatically added
#	url = "https://sh.dataspace.copernicus.eu/api/v1/catalog/1.0.0/search"
#	url = "https://sh.dataspace.copernicus.eu/api/v1/catalog/1.0.0/"
	url = "https://sh.dataspace.copernicus.eu/api/v1/catalog/1.0.0/collections/sentinel-2-l2a/queryables"
#	url = "https://sh.dataspace.copernicus.eu/api/v1/catalog/1.0.0/collections/sentinel-2-l2a"

	resp = oauth.get(url)


	print(json.dumps(json.loads(resp.content), indent=2))
	data = {
#	    "bbox": [13, 45, 14, 46],
	     "intersects":{
    "type": "Polygon", 
    "coordinates": [
        [
            [-90.43670654296876, 21.076811782249436], 
            [-89.65667724609375, 21.37635972888924 ], 
            [-89.0606689453125 , 21.419833053493477], 
            [-88.20648193359374, 21.703369345524266], 
            [-87.79449462890625, 21.619132728904603], 
            [-87.53631591796875, 21.53995662308543 ], 
            [-87.53631591796875, 21.460737306938086], 
            [-90.25543212890625, 20.8639448490769  ], 
            [-90.450439453125  , 20.840844707411335], 
            [-90.43670654296876, 21.076811782249436]  
        ]
    ]
},
	    "datetime": "2019-01-01T00:00:00Z/..", #"2019-12-10T23:59:59Z",
	    "collections": ["sentinel-2-l2a"],
	    "limit": 100,
	    "filter": "eo:cloud_cover<3",
#	    "fields": {"include":["links"]},
	}

	url = "https://sh.dataspace.copernicus.eu/api/v1/catalog/1.0.0/search"


#	print("FEATURES:",len(json.loads(response.content)["features"]))
#	for i in json.loads(response.content)["features"]:
#		print(i["id"], i["properties"]["eo:cloud_cover"], i["properties"]["datetime"])
##		print(i.keys())
#		print(i["assets"]["data"]["href"])
	productList = []
	response = None
	while  response is None or response.status_code==200:
		response = oauth.post(url, json=data)
		content = json.loads(response.content)
		for i in json.loads(response.content)["features"]:
#			print(i["assets"]["data"]["href"])
			productList.append(i["assets"]["data"]["href"])
		if "next" in content["context"]:
			data["next"]= content["context"]["next"]
			print(content["context"])
		else:
			break;
	
	with open("productList.txt", 'w') as fp:
		for item in productList:
			fp.write("%s\n" % item)
	print(response)

#===============================================================================
def main(argv):

#	if len(sys.argv) != 2:
#		print ("Usage text")
#	else:
	example()


if __name__ == "__main__":
	main(sys.argv)
