#!/bin/sh
#Convert L2A Products to L3A using L2AProductListToL3A Process

DATE=$1
TILE=$2
INDIR=$3
OUTDIR=$4

cd $INDIR
for f in $(ls | egrep $DATE.{21}$TILE) ; do
	TMPDIR=MSIL3A_$DATE"_"$TILE"/"
	cd $OUTDIR

        if [ ! -d $TMPDIR"L2A/TCI/" ]; then
                mkdir -p $TMPDIR"L2A/TCI/"
        fi

        if [ ! -d $TMPDIR"L2A/SCL/" ]; then
                mkdir -p $TMPDIR"L2A/SCL/"
        fi


	JP2DIR=$TMPDIR"GRANULE/L3A_"$TILE"_"$DATE"/IMG_DATA/R60m/" 
        if [ ! -d $JP2DIR ]; then
                mkdir -p $JP2DIR
        fi

	cd .. 
	ln -s $INDIR$f $OUTDIR$TMPDIR"L2A/"$f
	unzip -n -j $OUTDIR$TMPDIR"L2A/"$f *TCI_60m.jp2 -d $OUTDIR$TMPDIR"L2A/TCI/"
        unzip -n -j $OUTDIR$TMPDIR"L2A/"$f *SCL_60m.jp2 -d $OUTDIR$TMPDIR"L2A/SCL/"


	echo $f
done


cd $OUTDIR$TMPDIR"L2A/"
L2AtoL3A.py $OUTDIR$TMPDIR"L2A/"
