#!/bin/sh
JP2DIR=$1	#JP2 Directory
OUTDIR=$2
POLYGON=$3	#Crop Window
JOBS=${4:-1}
#DIRNAME=$(echo $JP2DIR | cut -d"/" -f1)
#echo "POLYGON"
#echo $POLYGON


BOX=$(polygonToBox.py "$POLYGON")

echo "Polygon BOX" $BOX

if [ "$#" -le 1 ]; then
	echo "Usage " $0 " <Parent Directory with subdirectories> <POLYGON> [jobs]" 
	exit
fi
echo "cd " $JP2DIR
cd $JP2DIR
for f in $(ls);  do echo ${f}; done;

ls -d */ | parallel -q --jobs $JOBS mergeImages.sh {} $OUTDIR "$BOX"
#ls -d */ | parallel -q --jobs $JOBS test.sh {} ../../{} "$BOX"



